# sha4.h File Reference

## Detailed Description

Copyright (C) 2006-2009, Paul Bakker <polarssl_maintainer at polarssl.org> All rights reserved.

Joined copyright on original XySSL code with: Christophe Devine

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Definition in file sha4.h.

Go to the source code of this file.

## Data Structures
struct | sha4_context
| SHA-512 context structure. More...
## Defines
#define | int64 long long
#define | UL64(x) x##ULL
## Functions
void | sha4 (unsigned char *input, int ilen, unsigned char output[64], int is384)
| Output = SHA-512( input buffer ).
int | sha4_file (char *path, unsigned char output[64], int is384)
| Output = SHA-512( file contents ).
void | sha4_finish (sha4_context *ctx, unsigned char output[64])
| SHA-512 final digest.
void | sha4_hmac (unsigned char *key, int keylen, unsigned char *input, int ilen, unsigned char output[64], int is384)
| Output = HMAC-SHA-512( hmac key, input buffer ).
void | sha4_hmac_finish (sha4_context *ctx, unsigned char output[64])
| SHA-512 HMAC final digest.
void | sha4_hmac_starts (sha4_context *ctx, unsigned char *key, int keylen, int is384)
| SHA-512 HMAC context setup.
void | sha4_hmac_update (sha4_context *ctx, unsigned char *input, int ilen)
| SHA-512 HMAC process buffer.
int | sha4_self_test (int verbose)
| Checkup routine.
void | sha4_starts (sha4_context *ctx, int is384)
| SHA-512 context setup.
void | sha4_update (sha4_context *ctx, unsigned char *input, int ilen)
| SHA-512 process buffer.

## Define Documentation

#define int64 long long

Definition at line 31 of file sha4.h.

#define UL64 | ( | x |  | ) | x##ULL

Definition at line 30 of file sha4.h.

## Function Documentation

void sha4 | ( | unsigned char * | input,
|  | int | ilen,
|  | unsigned char | output[64],
|  | int | is384 |
| ) |  |  |

Output = SHA-512( input buffer ).

Parameters:

  | input | buffer holding the data
  | ilen | length of the input data
  | output | SHA-384/512 checksum result
  | is384 | 0 = use SHA512, 1 = use SHA384

int sha4_file | ( | char * | path,
|  | unsigned char | output[64],
|  | int | is384 |
| ) |  |  |

Output = SHA-512( file contents ).

Parameters:

  | path | input file name
  | output | SHA-384/512 checksum result
  | is384 | 0 = use SHA512, 1 = use SHA384

Returns:
  0 if successful, 1 if fopen failed, or 2 if fread failed

void sha4_finish | ( | sha4_context * | ctx,
|  | unsigned char | output[64] |
| ) |  |  |

SHA-512 final digest.

Parameters:

  | ctx | SHA-512 context
  | output | SHA-384/512 checksum result

void sha4_hmac | ( | unsigned char * | key,
|  | int | keylen,
|  | unsigned char * | input,
|  | int | ilen,
|  | unsigned char | output[64],
|  | int | is384 |
| ) |  |  |

Output = HMAC-SHA-512( hmac key, input buffer ).

Parameters:

  | key | HMAC secret key
  | keylen | length of the HMAC key
  | input | buffer holding the data
  | ilen | length of the input data
  | output | HMAC-SHA-384/512 result
  | is384 | 0 = use SHA512, 1 = use SHA384

void sha4_hmac_finish | ( | sha4_context * | ctx,
|  | unsigned char | output[64] |
| ) |  |  |

SHA-512 HMAC final digest.

Parameters:

  | ctx | HMAC context
  | output | SHA-384/512 HMAC checksum result

void sha4_hmac_starts | ( | sha4_context * | ctx,
|  | unsigned char * | key,
|  | int | keylen,
|  | int | is384 |
| ) |  |  |

SHA-512 HMAC context setup.

Parameters:

  | ctx | HMAC context to be initialized
  | is384 | 0 = use SHA512, 1 = use SHA384
  | key | HMAC secret key
  | keylen | length of the HMAC key

void sha4_hmac_update | ( | sha4_context * | ctx,
|  | unsigned char * | input,
|  | int | ilen |
| ) |  |  |

SHA-512 HMAC process buffer.

Parameters:

  | ctx | HMAC context
  | input | buffer holding the data
  | ilen | length of the input data

int sha4_self_test | ( | int | verbose | ) |

Checkup routine.

Returns:
  0 if successful, or 1 if the test failed

void sha4_starts | ( | sha4_context * | ctx,
|  | int | is384 |
| ) |  |  |

SHA-512 context setup.

Parameters:

  | ctx | context to be initialized
  | is384 | 0 = use SHA512, 1 = use SHA384

void sha4_update | ( | sha4_context * | ctx,
|  | unsigned char * | input,
|  | int | ilen |
| ) |  |  |

SHA-512 process buffer.

Parameters:

  | ctx | SHA-512 context
  | input | buffer holding the data
  | ilen | length of the input data